RepHeaderRemember = LibStub("AceAddon-3.0"):NewAddon("RepHeaderRemember", "AceHook-3.0")

local defaults = {
	profile = {
		HeaderCollapsed = {}
	},
}

-- Called when the addon is loaded
function RepHeaderRemember:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RepHeaderRememberDB", defaults)
end

-- Called when the addon is enabled
function RepHeaderRemember:OnEnable()
	RepHeaderRemember:Hook("ReputationFrame_Update", true)
	RepHeaderRemember:Hook("CollapseFactionHeader", true)
	RepHeaderRemember:Hook("ExpandFactionHeader", true)
end

-- Called when the addon is Disabled
function RepHeaderRemember:OnDisable()
	RepHeaderRemember:UnhookAll()
end

-- Saves the name of a header that was collapsed
function RepHeaderRemember:CollapseFactionHeader(index, ...)
	local name, _, _, _, _, _, _, _, isHeader = GetFactionInfo(index)
	if (isHeader) then 
		self.db.profile.HeaderCollapsed[name] = true
	end
end

-- Saves the name of a header that was expanded
function RepHeaderRemember:ExpandFactionHeader(index, ...)
	local name, _, _, _, _, _, _, _, isHeader = GetFactionInfo(index)
	if (isHeader) then 
		self.db.profile.HeaderCollapsed[name] = false
	end
end

-- If Rep frame is being shown, collapse headers.
function RepHeaderRemember:ReputationFrame_Update(...)
	-- Reads list of saved header names and collapses or expands them to match saved value.
	for index=1, GetNumFactions(), 1 do
		local name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
		if isHeader and self.db.profile.HeaderCollapsed[name] ~= nil then
			if self.db.profile.HeaderCollapsed[name] and not isCollapsed then
				CollapseFactionHeader(index)
			elseif not self.db.profile.HeaderCollapsed[name] and isCollapsed then
				ExpandFactionHeader(index) 
			end
		end
	end
end

